unit CBuf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Config;

type
  PCBbuf = ^TCBbuf;
  TCBbuf = array [1..1] of char;

  TCB = class
    constructor Create(ASize : integer);
    destructor Destroy; override;
  private
    CB  : PCBbuf;
    cbs : integer;
    cbe : integer;
    cbsz: integer;
    mtx : THANDLE;
    function ScanMem(var buf; len : word; s : string) : word;
  public
    function AddCB(s : string) : boolean;
    function GetCB(var out : string) : boolean;
  end;

implementation

constructor TCB.Create;
begin
CB:=nil;
cbsz:=ASize;
getmem(CB,cbsz+1);
cbs:=1;
cbe:=1;
mtx:=CreateMutex(nil,false,nil);
end;

destructor TCB.Destroy;
begin
if CB <> nil then freemem(CB);
CB:=nil;
CloseHandle(mtx);
end;

function tCB.AddCB(s : string) : boolean;
var
 l : integer;
begin
result:=false;
WaitForSingleObject(mtx,INFINITE);
try
  if length(s) = 0 then exit;
  l:=length(s);
  if cbe >= cbs then
    begin
    if (cbsz-cbe+1) >= l then
      begin
      copymemory(@CB[cbe],@s[1],l);
      cbe:=cbe+l;
      if cbe > cbsz then cbe:=1;
      end
    else
      begin
      if (cbsz-cbe+cbs-1) < l then
        exit
      else
        begin
        copymemory(@CB[cbe],@s[1],cbsz-cbe+1);
        s:=copy(s,cbsz-cbe+2,1000);
        l:=length(s);
        copymemory(CB,@s[1],l);
        cbe:=l+1;
        end;
      end;
    end
  else
    begin
    if (cbs-cbe-1) < l then
      exit
    else
      begin
      copymemory(@CB[cbe],@s[1],l);
      cbe:=cbe+l;
      end;
    end;
  result:=true;
finally
  ReleaseMutex(mtx);
  end;
end;

type
 ts = array [1..$fff0] of char;

function TCB.ScanMem(var buf; len : word; s : string) : word;
var
 i,i1 : word;
 p    : boolean;
begin
ScanMem:=0;
if (s = '') or (len < length(s)) then exit;
for i:=1 to (len-length(s)+1) do
  begin
  if ts(buf)[i] = s[1] then
    begin
    p:=true;
    for i1:=2 to length(s) do
      if ts(buf)[i+i1-1] <> s[i1] then p:=false;
    if p then
      begin
      ScanMem:=i;
      exit;
      end;
    end;
  end;
end;

function tCB.GetCB(var out : string) : boolean;
var
 i : word;
 s : string;
begin
WaitForSingleObject(mtx,INFINITE);
try
  result:=false;
  if cbe = cbs then exit;
  if cbe > cbs then
    begin
    i:=ScanMem(CB[cbs],cbe-cbs,#13#10);
    if i = 0 then exit;
    CB[cbs+i-1]:=#0;
    s:=strpas(@CB[cbs]);
    cbs:=cbs+i+1;
    end
  else
    begin
    i:=ScanMem(CB[cbs],cbsz-cbs+1,#13#10);
    if i > 0 then
      begin
      CB[cbs+i-1]:=#0;
      s:=strpas(@CB[cbs]);
      cbs:=cbs+i+1;
      if cbs > cbsz then cbs:=1;
      end
    else
      begin
      if (CB[cbsz] = #13) and (CB[1] = #10) then
        begin
        CB[cbsz]:=#0;
        s:=strpas(@CB[cbs]);
        cbs:=2;
        end
      else
        begin
        i:=ScanMem(CB^[1],cbe-1,#13#10);
        if i = 0 then exit;
        CB[cbsz+1]:=#0;
        s:=strpas(@CB[cbs]);
        CB[i]:=#0;
        s:=s+strpas(@CB[1]);
        cbs:=i+2;
        end;
      end;
    end;
  out:=s;
  result:=true;
finally
  ReleaseMutex(mtx);
  end;
end;

end.
