unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ShellApi, Config, Server;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit3: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Button4: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
  private
    nif : tNotifyIconData;
    OldWndProc : TWndMethod;
    Server : TListener;
    procedure LocalMenu(b : tMouseButton);
    procedure FullMsg(var msg : tmessage); message WM_FULL;
    procedure MyDispatch(var msg : tMessage);
    procedure Full;
    procedure Small;
    procedure StartServer;
    procedure StopServer;
  end;

var
  Form1: TForm1;

implementation

uses Users, Hosts, Lsts, Domains;

{$R *.DFM}

procedure TForm1.MyDispatch(var msg : tMessage);
begin
if msg.wparam = cmSmall then
  begin
  small;
  exit;
  end;
if msg.wparam = cmFull then
  begin
  Full;
  exit;
  end;
if msg.wparam = cmExitImm then
  begin
  Close;
  exit;
  end;
if msg.wparam = cmHosts then
  begin
  Form3.ShowModal;
  exit;
  end;
if msg.wparam = cmUsers then
  begin
  Form2.ShowModal;
  exit;
  end;
if msg.msg = WM_SYSCOMMAND then
  begin
  if (msg.wparam = SC_MINIMIZE) or (msg.wparam = SC_ICON) then
    begin
    small;
    exit;
    end;
  end;
OldWndProc(msg);
end;

procedure TForm1.FullMsg;
begin
if msg.lparam = WM_LBUTTONDOWN then Full;
if msg.lparam = WM_RBUTTONDOWN then LocalMenu(mbRight);
end;

procedure TForm1.LocalMenu(b : tMouseButton);
var
 m : hmenu;
 p : tPoint;
begin
if b = mbRight then
  begin
  GetCursorPos(p);
  m:=CreatePopupMenu;
  if Cfg.Show then
    begin
    AppendMenu(m,MF_STRING,cmHosts,'Hosts');
    AppendMenu(m,MF_STRING,cmUsers,'Users');
    AppendMenu(m,MF_SEPARATOR,cmNoCommand,'');
    AppendMenu(m,MF_STRING,cmSmall,'&Minimize');
    AppendMenu(m,MF_SEPARATOR,cmNoCommand,'');
    AppendMenu(m,MF_STRING,cmExitImm,'E&xit');
    end
  else
    begin
    AppendMenu(m,MF_STRING,cmHosts,'Hosts');
    AppendMenu(m,MF_STRING,cmUsers,'Users');
    AppendMenu(m,MF_SEPARATOR,cmNoCommand,'');
    AppendMenu(m,MF_STRING,cmFull,'Restore');
    AppendMenu(m,MF_SEPARATOR,cmNoCommand,'');
    AppendMenu(m,MF_STRING,cmExitImm,'E&xit');
    end;
  TrackPopupMenu(m,0,p.x,p.y,0,handle,nil);
  DestroyMenu(m);
  end;
end;

procedure TForm1.Full;
begin
nif.cbSize:=sizeof(nif);
nif.Wnd:=Handle;
nif.uID:=1;
nif.uFlags:=NIF_ICON + NIF_MESSAGE + NIF_TIP;
nif.uCallbackMessage:=WM_FULL;
nif.hIcon:=Application.Icon.Handle;
strpcopy(pchar(@nif.szTip),'NTPOP 1.0 - click to configure');
shell_notifyicon(NIM_DELETE,@nif);
ShowWindow(Application.Handle,SW_SHOW);
ShowWindow(Handle,SW_SHOW);
SetFocus;
Cfg.Show:=true;
end;

procedure TForm1.Small;
begin
nif.cbSize:=sizeof(nif);
nif.Wnd:=Handle;
nif.uID:=1;
nif.uFlags:=NIF_ICON + NIF_MESSAGE + NIF_TIP;
nif.uCallbackMessage:=WM_FULL;
nif.hIcon:=application.Icon.Handle;
strpcopy(pchar(@nif.szTip),'NTPOP 1.0 - click to configure');
shell_notifyicon(NIM_ADD,@nif);
ShowWindow(Application.Handle,SW_HIDE);
ShowWindow(Handle,SW_HIDE);
Cfg.Show:=false;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
if Cfg.Show then
  Button1.SetFocus;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
Form2.ShowModal;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Form3.ShowModal;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
OldWndProc:=WndProc;
WindowProc:=MyDispatch;
Server:=nil;
HostList:=THostList.Create;
DomainList:=TDomainList.Create;
UserList:=TUserList.Create;
LoadConfiguration;
edit1.text:=IntToStr(Cfg.Port);
edit2.text:=Cfg.Spool;
edit3.text:=IntToStr(Cfg.TOut);
edit4.text:=IntToStr(Cfg.LogLvl);
if Cfg.Run then
  begin
  button1.caption:='Stop';
  StartServer;
  end
else
  button1.caption:='Start';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
SaveConfiguration;
WindowProc:=OldWndProc;
nif.cbSize:=sizeof(nif);
nif.Wnd:=Handle;
nif.uID:=1;
nif.uFlags:=NIF_ICON + NIF_MESSAGE + NIF_TIP;
nif.uCallbackMessage:=WM_FULL;
nif.hIcon:=Application.Icon.Handle;
strpcopy(pchar(@nif.szTip),'NTPOP 1.0 - click to configure');
shell_notifyicon(NIM_DELETE,@nif);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
if not Cfg.Show then Small;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if Button = mbRight then LocalMenu(Button);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
if Cfg.Run then
  StopServer
else
  StartServer;
end;

procedure TForm1.StartServer;
begin
Server:=TListener.Create(self);
if Server.Run then
  begin
  Cfg.Run:=true;
  button1.Caption:='Stop';
  end;
end;

procedure TForm1.StopServer;
begin
if assigned(Server) then Server.Terminate;
Server:=nil;
Cfg.Run:=false;
button1.Caption:='Start';
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
Form4.ShowModal;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
Cfg.Port:=StrToIntDef(edit1.text,110);
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
Cfg.TOut:=StrToIntDef(edit3.text,60);
end;

procedure TForm1.Edit4Change(Sender: TObject);
begin
Cfg.LogLvl:=StrToIntDef(edit4.text,2);
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
Cfg.Spool:=Alltrim(edit2.text);
end;

end.
